var currentCoreVersion, logger, utils;

currentCoreVersion = require('../../package.json').version;

logger = require('winston');

utils = require('../utils');

exports.getAboutInformation = function*() {
  var e, error;
  try {
    this.body = (yield {
      currentCoreVersion: currentCoreVersion,
      serverTimezone: utils.serverTimezone()
    });
    this.status = 200;
    return logger.info("User " + this.authenticated.email + " successfully fetched 'about' information");
  } catch (error) {
    e = error;
    this.body = e.message;
    return utils.logAndSetResponse(this, 500, "Could not fetch 'about' info via the API " + e, 'error');
  }
};

//# sourceMappingURL=about.js.map
