var Channel, Q, logger;

Channel = require("../model/channels").Channel;

logger = require('winston');

Q = require("q");

exports.inGroup = function(group, user) {
  return user.groups.indexOf(group) >= 0;
};

exports.getUserViewableChannels = function(user) {
  if (exports.inGroup('admin', user)) {
    return Channel.find({}).exec();
  } else {
    return Channel.find({
      txViewAcl: {
        $in: user.groups
      }
    }).exec();
  }
};

exports.getUserRerunableChannels = function(user) {
  if (exports.inGroup('admin', user)) {
    return Channel.find({}).exec();
  } else {
    return Channel.find({
      txRerunAcl: {
        $in: user.groups
      }
    }).exec();
  }
};

//# sourceMappingURL=authorisation.js.map
