var Event, authorisation, utils;

Event = require('../model/events').Event;

authorisation = require('./authorisation');

utils = require("../utils");

exports.getLatestEvents = function*(receivedTime) {
  var err, error, results, rtDate;
  if (!authorisation.inGroup('admin', this.authenticated)) {
    utils.logAndSetResponse(this, 403, "User " + this.authenticated.email + " is not an admin, API access to events denied.", 'info');
    return;
  }
  try {
    rtDate = new Date(Number(receivedTime));
    results = (yield Event.find({
      'created': {
        '$gte': rtDate
      }
    }).sort({
      'normalizedTimestamp': 1
    }).exec());
    return this.body = {
      events: results
    };
  } catch (error) {
    err = error;
    return utils.logAndSetResponse(this, 500, "Could not fetch the latest events via the API: " + err, 'error');
  }
};

//# sourceMappingURL=events.js.map
