var Client, Q, SDC, application, config, domain, dummyClient, logger, os, sdc, statsdServer;

Q = require("q");

Client = require("../model/clients").Client;

logger = require("winston");

config = require('../config/config');

statsdServer = config.get('statsd');

application = config.get('application');

SDC = require('statsd-client');

os = require('os');

domain = (os.hostname()) + "." + application.name + ".appMetrics";

sdc = new SDC(statsdServer);

dummyClient = new Client({
  clientID: 'DUMMY-TCP-USER',
  clientDomain: 'openhim.org',
  name: 'DUMMY-TCP-USER',
  roles: ['tcp']
});

exports.authenticateUser = function(ctx, done) {
  ctx.authenticated = dummyClient;
  return done(null, dummyClient);
};


/*
 * Koa middleware for bypassing authentication for tcp requests
 */

exports.koaMiddleware = function*(next) {
  var authenticateUser, startTime;
  if (statsdServer.enabled) {
    startTime = new Date();
  }
  authenticateUser = Q.denodeify(exports.authenticateUser);
  (yield authenticateUser(this));
  if (this.authenticated != null) {
    if (statsdServer.enabled) {
      sdc.timing(domain + ".tcpBypassAuthenticationMiddleware", startTime);
    }
    return (yield next);
  } else {
    this.response.status = 401;
    if (statsdServer.enabled) {
      return sdc.timing(domain + ".tcpBypassAuthenticationMiddleware", startTime);
    }
  }
};

//# sourceMappingURL=tcpBypassAuthentication.js.map
