var EventsSchema, Schema, connectionDefault, mongoose, server;

mongoose = require("mongoose");

server = require("../server");

connectionDefault = server.connectionDefault;

Schema = mongoose.Schema;

exports.eventTypes = ['channel', 'primary', 'route', 'orchestration'];

EventsSchema = new Schema({
  "created": {
    type: Date,
    "default": Date.now,
    expires: '1h'
  },
  "channelID": {
    type: Schema.Types.ObjectId,
    required: true
  },
  "transactionID": {
    type: Schema.Types.ObjectId,
    required: true
  },
  "type": {
    type: String,
    "enum": exports.EventTypes
  },
  "event": {
    type: String,
    "enum": ['start', 'end']
  },
  "name": String,
  "status": Number,
  "statusType": {
    type: String,
    "enum": ['success', 'error']
  },
  "normalizedTimestamp": String,
  "mediator": String,
  "autoRetryAttempt": Number
});

exports.Event = connectionDefault.model('Event', EventsSchema);

//# sourceMappingURL=events.js.map
