var CertificateSchema, KeystoreSchema, Schema, certificate, connectionDefault, mongoose, server;

mongoose = require("mongoose");

server = require("../server");

connectionDefault = server.connectionDefault;

Schema = mongoose.Schema;

certificate = {
  country: String,
  state: String,
  locality: String,
  organization: String,
  organizationUnit: String,
  commonName: String,
  emailAddress: String,
  validity: {
    start: Date,
    end: Date
  },
  data: String,
  fingerprint: String
};

CertificateSchema = new Schema(certificate);

KeystoreSchema = new Schema({
  key: String,
  passphrase: String,
  cert: certificate,
  ca: [certificate]
});

exports.Keystore = connectionDefault.model('Keystore', KeystoreSchema);

exports.Certificate = connectionDefault.model('Certificate', CertificateSchema);

//# sourceMappingURL=keystore.js.map
