var ChannelDef, MediatorSchema, RouteDef, Schema, configDef, connectionDefault, mongoose, server;

mongoose = require("mongoose");

server = require("../server");

connectionDefault = server.connectionDefault;

Schema = mongoose.Schema;

RouteDef = require('./channels').RouteDef;

ChannelDef = require('./channels').ChannelDef;

exports.configParamTypes = ['string', 'bool', 'number', 'option', 'bigstring', 'map', 'struct', 'password'];

exports.configDef = configDef = {
  "param": String,
  "displayName": String,
  "description": String,
  "type": {
    type: String,
    "enum": exports.configParamTypes
  },
  "values": [
    {
      type: String
    }
  ],
  "template": {
    type: Array
  },
  "array": Boolean
};

MediatorSchema = new Schema({
  "urn": {
    type: String,
    required: true,
    unique: true
  },
  "version": {
    type: String,
    required: true
  },
  "name": {
    type: String,
    required: true
  },
  "description": String,
  "endpoints": [RouteDef],
  "defaultChannelConfig": [ChannelDef],
  "configDefs": [configDef],
  "config": Object,
  "_configModifiedTS": Date,
  "_uptime": Number,
  "_lastHeartbeat": Date
});

exports.Mediator = connectionDefault.model('Mediator', MediatorSchema);

//# sourceMappingURL=mediators.js.map
